---
title: 'Element: copy event'
slug: Web/API/Element/copy_event
tags:
  - API
  - Clipboard API
  - Element
  - Event
  - Reference
  - Web
---
<div>{{APIRef}}</div>

<p><span class="seoSummary">The <strong><code>copy</code></strong> event fires when the user initiates a copy action through the browser's user interface.</span></p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("ClipboardEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("HTMLElement/oncopy", "oncopy")}}</td>
  </tr>
 </tbody>
</table>

<p>The event's default action is to copy the selection (if any) to the clipboard.</p>

<p>A handler for this event can <em>modify</em> the clipboard contents by calling {{domxref("DataTransfer.setData", "setData(format, data)")}} on the event's  {{domxref("ClipboardEvent.clipboardData")}} property, and cancelling the event's default action using {{domxref("Event/preventDefault", "event.preventDefault()")}}.</p>

<p>However, the handler cannot <em>read</em> the clipboard data.</p>

<p>It's possible to construct and dispatch a <a href="/en-US/docs/Web/Guide/Events/Creating_and_triggering_events">synthetic</a> <code>copy</code> event, but this will not affect the system clipboard.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Live_example">Live example</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;div class="source" contenteditable="true"&gt;Try copying text from this box...&lt;/div&gt;
&lt;div class="target" contenteditable="true"&gt;...and pasting it into this one&lt;/div&gt;
</pre>

<div class="hidden">
<h4 id="CSS">CSS</h4>

<pre class="brush: css">div.source, div.target {
    border: 1px solid gray;
    margin: .5rem;
    padding: .5rem;
    height: 1rem;
    background-color: #e9eef1;
}</pre>
</div>

<h4 id="JS">JS</h4>

<pre class="brush: js">const source = document.querySelector('div.source');

source.addEventListener('copy', (event) =&gt; {
    const selection = document.getSelection();
    event.clipboardData.setData('text/plain', selection.toString().toUpperCase());
    event.preventDefault();
});
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Live_example', '100%', '100px') }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Clipboard API', '#clipboard-event-copy')}}</td>
   <td>{{Spec2('Clipboard API')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.copy_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Related events: {{domxref("Element/cut_event", "cut")}}, {{domxref("Element/paste_event", "paste")}}</li>
 <li>This event on {{domxref("Document")}} targets: {{domxref("Document/copy_event", "copy")}}</li>
 <li>This event on {{domxref("Window")}} targets: {{domxref("Window/copy_event", "copy")}}</li>
</ul>
